//+------------------------------------------------------------------+ 
//|   !TRO_Train                                                     | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1



//---- indicator parameters  


extern bool  Sound.Alert      = true;
extern string Sound.File     = "train_horn.wav" ; // TRO

extern bool  Show.Comment     = false;

  

  int win = 0;
extern int price.x.offset = 10 ; 
extern int price.y.offset = 100 ; 
extern int myFontSize     = 20;


extern int   myStationSize   = 10;

extern string Up_Message = "LONG" ;
extern string Eq_Message = "WAIT" ;
extern string Dn_Message = "SHORT" ;

extern color Up_color = Blue;
extern color Eq_color = Orange;
extern color Dn_color = Red;

 
//+------------------------------------------------------------------+ 


color HighColor, LowColor, MidColor, Mid1Color, CloseColor, ClOpColor;

  double close, size ;
  double bid, ask;
string tMessage, tPrice, tChar, tTrain, tMan  ;


int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;
 
//+------------------------------------------------------------------+ 
int init() 
  { 
  
   tTrain       = CharToStr(116) ; 
   tMan         = CharToStr(130) ; 
   
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
   deinit() ; 
    
   return(0); 
  } 


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
        
   ObDeleteObjectsByPrefix("2PSY");  
   TRO() ;
   return(0);
  }
 
//+------------------------------------------------------------------+ 
int start() 
  { 
double xPrice ;  
double xopen   = iOpen(NULL,0,0) ; 
double xclose  = iClose(NULL,0,0) ; 
 

double xdiff   = xclose - xopen ;

double xPsycho = myStationSize * point;

close = NormalizeDouble(Close[0],digits);
bid   = NormalizeDouble(Bid,digits); 
ask   = NormalizeDouble(Ask,digits);

size  = (High[0] - Low[0]) / point ;


xPrice = close - MathMod(close,xPsycho) ;

xPrice = NormalizeDouble(xPrice,digits);

if( xdiff > 0) xPrice = xPrice + xPsycho ;

if(Show.Comment) 
{
   Comment(
      "xPrice=", DoubleToStr(xPrice, Digits),  "\n" ,   
      "Bid ", DoubleToStr(bid, digits),  "\n" ,   
      "Ask ", DoubleToStr(ask, digits)  , "\n" ,   
      "size " , size  , "\n" ,  
      "myStationSize " , myStationSize  , "\n" ,        
          
  "" );   
}

tChar = tTrain ;

if( size < myStationSize && xdiff > 0 && ask == xPrice ) { tMessage = Up_Message ; ClOpColor = Up_color ; } 
else {
if( size < myStationSize && xdiff < 0 && bid == xPrice ) { tMessage = Dn_Message ; ClOpColor = Dn_color ; } 
else {
                          tChar = tMan ;         tMessage = Eq_Message ; ClOpColor = Eq_color ; } }  
                                   
tPrice = " " + DoubleToStr(xPrice, digits) ;  

if( Sound.Alert && tMessage != Eq_Message ) { PlaySound(Sound.File) ; }


//+------------------------------------------------------------------+  
 
                 
                    
   ObjectCreate("2PSY30", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("2PSY30",Symbol(), myFontSize , "Arial Bold", ClOpColor );
   ObjectSet("2PSY30", OBJPROP_CORNER, 1);
   ObjectSet("2PSY30", OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet("2PSY30", OBJPROP_YDISTANCE, price.y.offset); 
   ObjectSet("2PSY30",OBJPROP_BACK,true);       

//+------------------------------------------------------------------+  
 
tPrice = " " + DoubleToStr(close, digits) ;               
                    
   ObjectCreate("2PSY31", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("2PSY31",tPrice, myFontSize , "Arial Bold", ClOpColor );
   ObjectSet("2PSY31", OBJPROP_CORNER, 1);
   ObjectSet("2PSY31", OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet("2PSY31", OBJPROP_YDISTANCE, myFontSize+price.y.offset); 
   ObjectSet("2PSY31",OBJPROP_BACK,false); 

//+------------------------------------------------------------------+        
   ObjectCreate("2PSY32", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("2PSY32",tMessage, myFontSize , "Arial Bold", ClOpColor );
   ObjectSet("2PSY32", OBJPROP_CORNER, 1);
   ObjectSet("2PSY32", OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet("2PSY32", OBJPROP_YDISTANCE, 2*myFontSize+price.y.offset); 
   ObjectSet("2PSY32",OBJPROP_BACK,true); 
   
   
   ObjectCreate("2PSY33", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("2PSY33",tChar, myFontSize , "Webdings", ClOpColor );
   ObjectSet("2PSY33", OBJPROP_CORNER, 1);
   ObjectSet("2PSY33", OBJPROP_XDISTANCE, 90+price.x.offset); 
   ObjectSet("2PSY33", OBJPROP_YDISTANCE, 2*myFontSize+price.y.offset); 
   ObjectSet("2PSY33",OBJPROP_BACK,true);    
//+------------------------------------------------------------------+      
   
   WindowRedraw();    
 
 

 
   return(0); 
} 

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
 
//+------------------------------------------------------------------+

/*
 
 
   
 string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}
  
   
*/   